ECHO OFF
CLS
IF "%1"=="" GOTO HELP
PATH \;%1
CD \ISR-20
IF NOT EXIST PUB_DOM.AIN GOTO TVA
CD \
ECHO              This program is a work of the Tennessee Valley
ECHO              Authority (TVA), U.S. Government, and is in
ECHO              the public domain.
ECHO .
ECHO TVA MAKES NO REPRESENTATION OR WARRENTY OF ANY KIND WHATSOEVER, 
ECHO INCLUDING, BUT NOT LIMITED TO, REPRESENTATIONS OR WARRENTIES, 
ECHO EXPRESSED OR IMPLIED, OF MERCHANTABILITY, FITNESS FOR SPECIFIC 
ECHO USE OR PURPOSE, accuracy or completeness of processes, 
ECHO procedures, designs, definitions, instructions, information, or 
ECHO functioning of the program(s) and related material; TVA further 
ECHO expressly disclaims any knowledge or purpose for which the 
ECHO program(s) may be utilized or its applicability for such use, 
ECHO nor shall the fact of making it available constitute any such 
ECHO representation, warranty, or knowledge, nor does TVA assume any 
ECHO liability, responsibility, or obligation arising from the use or 
ECHO malfunctioning of the computer program(s) or related materials.
ECHO .
PAUSE
CLS
GOTO TVA1
:TVA
ECHO If there is a question directly below, just press the RETURN key.
IF NOT "%2"=="" GOTO USERD
ECHO .
ECHO .
MSPOOL2 1 1
CLS
ECHO .
ECHO The print spooler program MSPOOL2.COM was found to exist in this system.
ECHO Since this system was found to have within it the program MSPOOL2.COM
ECHO (which it uses as a printer spooler, this is the TVA version of ISR-20, and
ECHO this system is, therefore, not in public domain.  Otherwise, it would
ECHO be in public domain.
ECHO .
ECHO A printer buffer of 7K has been installed within computer memory
ECHO if the buffer size has not been set previously since the last time
ECHO DOS was booted.
GOTO DEFT
:USERD
IF "%2"=="9" GOTO USERE
IF "%2"=="8" GOTO USERE
IF "%2"=="7" GOTO USERE
IF "%2"=="6" GOTO USERE
IF "%2"=="5" GOTO USERE
IF "%2"=="4" GOTO USERE
IF "%2"=="3" GOTO USERE
IF "%2"=="2" GOTO USERE
IF "%2"=="1" GOTO USERE
GOTO HELP
:USERE
ECHO .
ECHO .
MSPOOL2 1 %2
CLS
ECHO A printer buffer of %2 * 7K has been installed within computer memory
ECHO if the buffer size has not been set previously since the last time
ECHO DOS was booted.
:DEFT
ECHO .
:TVA1
ECHO Please press the RETURN key once more, if you wish, to automate
ECHO system loading (if you are using the dBASE III Plus operating system).
CD \ISR-20
IF EXIST ISR.EXE GOTO START2
DBASE
CLS
CD \
GOTO END
:START2
ISR.EXE
CLS
GOTO END
:HELP
CLS
CD\
ECHO To access the ISR-20 system of data bases, you should type "ISR"
ECHO followed by a space and then the PATH and the name of the 
ECHO DIRECTORY containing your copy of dBASE III Plus.  If you wish to
ECHO install within your computer memory a buffer greater than 7K, you
ECHO should type the number of multiples of 7K which you desire for
ECHO your printer buffer after the PATH and the name of the DIRECTORY
ECHO containing your copy of dBASE III Plus.  For example, if you wish
ECHO to install 9 * 7K (or 63K) of printer buffer within your computer
ECHO memory, and if the PATH and the name of the DIRECTORY containing
ECHO your copy of dBASE III Plus is "\DBASE", then the proper command
ECHO would be:
ECHO                        ISR \DBASE 9

ECHO For the compiled version it is "ISR \".
ECHO .
ECHO After the size of the buffer is set, it may not be set again until
ECHO DOS is rebooted.  The printer buffer is NOT available for the public
ECHO domain version.
:END
